//=========================================================================
//Copyright LizardOfOz.
//=========================================================================

if ("obj_tele" in this)
    return;

obj_tele <- null;
ent_glow <- null;

AddTimer(0.1, function()
{
    local vip = GetValidVIP(self.GetTeam());

    if (!vip)
    {
        if (obj_tele && obj_tele.IsValid())
            obj_tele.Kill();
        if (ent_glow && ent_glow.IsValid())
            ent_glow.Kill();
        obj_tele = null;
        ent_glow = null;
        return;
    }

    if (obj_tele && obj_tele.IsValid() && ent_glow && ent_glow.IsValid())
        return;

    if (obj_tele && obj_tele.IsValid())
        obj_tele.Kill();
    if (ent_glow && ent_glow.IsValid())
        ent_glow.Kill();
    obj_tele = null;
    ent_glow = null;

    obj_tele = Entities.CreateByClassname("obj_teleporter");
    obj_tele.SetAbsOrigin(vip.GetOrigin());
    obj_tele.DispatchSpawn();
    obj_tele.SetModel(API_GetString("vip_model"));
    obj_tele.AddEFlags(Constants.FEntityEFlags.EFL_NO_THINK_FUNCTION);
    obj_tele.SetSolid(Constants.ESolidType.SOLID_NONE);
    SetPropBool(obj_tele, "m_bPlacing", true);
    SetPropInt(obj_tele, "m_fObjectFlags", 2);
    SetPropEntity(obj_tele, "m_hBuilder", self);

    SetPropInt(obj_tele, "m_fEffects", 145);
    SetPropInt(obj_tele, "m_nNextThinkTick", 0x7FFFFFFF);
    EntFireByHandle(obj_tele, "SetParent", "!activator", 0, vip, vip);

    local name = obj_tele.GetScriptId();
    SetPropString(obj_tele, "m_iName", name);

    ent_glow = SpawnEntityFromTable("tf_glow", {
        target = name
        StartDisabled = 0
        GlowColor = GetFakeTeam(self) == TF_TEAM_RED ? "190 48 48 255" : "179 225 255 255"
    });
    SetPropBool(ent_glow, "m_bForcePurgeFixedupStrings", true);
    EntFireByHandle(ent_glow, "SetParent", "!activator", 0, vip, vip);
});